| dbxflat

## Function

Database b+tree indexing for flat file databases

## Description

dbxflat indexes a flat file database of one or more files, and builds EMBOSS B+tree format index files. These indexes allow access of flat files larger than 2Gb.

Having created the EMBOSS indexes for this file, a database can then be defined in the file emboss.defaults as something like:

    DB embl [
       type: N
       dbalias: embl   (see below)
       format: embl
       method: emboss
       directory: /data/embl
       file: *.dat
       indexdirectory: /data/embl/indexes
    ]

The index file 'basename' given to dbxflat must match the DB name in the definition. If not, then a 'dbalias' line must be given which specifies the basename of the indexes.

### Fields Indexed

By default, dbxflat will index the ID name and the accession number (if present).
If they are present in your database, you may also specify that dbxflat should index the Sequence Version and GI, the words in the description, the keywords and the organism words using the '-fields' qualifier with the appropriate values.

## Usage

Here is a sample session with dbxflat

    % dbxflat
    Database b+tree indexing for flat file databases
    Basename for index files: embl
    Resource name: embl
          EMBL : EMBL
         SWISS : Swiss-Prot, SpTrEMBL, TrEMBLnew
            GB : Genbank, DDBJ
        REFSEQ : Refseq
    Entry format [SWISS]: embl
    Wildcard database filename [*.dat]: rod.dat
    Database directory [.]: embl
            id : ID
           acc : Accession number
            sv : Sequence Version and GI
           des : Description
           key : Keywords
           org : Taxonomy
    Index fields [id,acc]:

    Processing file /ebi/services/idata/pmr/hgmp/test/embl/rod.dat

Go to the output files for this example

## Global Parameters

dbxflat requires that two global parameters be defined in the file emboss.defaults. These are:

    SET PAGESIZE 2048
    SET CACHESIZE 200

The above values are recommended for most systems. The PAGESIZE is a multiple of the size of disc pages the operating system buffers. The CACHESIZE is the number of disc pages dbxflat is allowed to cache.

## Resources

dbxflat will ask you for the name of a resource definition in the file emboss.defaults. This will be something like:

    RES embl [
       type: Index
       idlen:  15
       acclen: 15
       svlen:  20
       keylen: 25
       deslen: 25
       orglen: 25
    ]

The length definitions are the maximum lengths of 'words' in the field being indexed. Longer words will be truncated to the value set.

## Command line arguments

       Standard (Mandatory) qualifiers:
      [-dbname]            string     Basename for index files
      [-dbresource]        string     Resource name
       -idformat           menu       Entry format
       -filenames          string     Wildcard database filename
       -directory          directory  Database directory
       -fields             menu       Index fields

       Additional (Optional) qualifiers: (none)
       Advanced (Unprompted) qualifiers:
       -release            string     Release number
       -date               string     Index date
       -exclude            string     Wildcard filename(s) to exclude
       -indexoutdir        outdir     Index directory

       Associated qualifiers: (none)
       General qualifiers:
       -auto               boolean    Turn off prompts
       -stdout             boolean    Write standard output
       -filter             boolean    Read standard input, write standard output
       -options            boolean    Prompt for standard and additional values
       -debug              boolean    Write debug output to program.dbg
       -verbose            boolean    Report some/full command line options
       -help               boolean    Report command line options. More
                                      information on associated and general
                                      qualifiers can be found with -help -verbose
       -warning            boolean    Report warnings
       -error              boolean    Report errors
       -fatal              boolean    Report fatal errors
       -die                boolean    Report deaths

Standard (Mandatory) qualifiers | Allowed values | Default
--- | --- | ---
[-dbname] (Parameter 1) | Basename for index files | A string from 2 to 19 characters, matching regular expression /[A-z][A-z0-9_]+/ | Required
[-dbresource] (Parameter 2) | Resource name | A string from 2 to 19 characters, matching regular expression /[A-z][A-z0-9_]+/ | Required

-idformat

Entry format

EMBL | (EMBL)
SWISS | (Swiss-Prot, SpTrEMBL, TrEMBLnew)
GB | (Genbank, DDBJ)
REFSEQ | (Refseq)

SWISS

-filenames | Wildcard database filename | Any string is accepted | *.dat
-directory | Database directory | Directory | .

-fields

Index fields

id | (ID)
acc | (Accession number)
sv | (Sequence Version and GI)
des | (Description)
key | (Keywords)
org | (Taxonomy)

id,acc

Additional (Optional) qualifiers | Allowed values | Default
(none)
Advanced (Unprompted) qualifiers | Allowed values | Default
-release | Release number | A string up to 9 characters | 0.0
-date | Index date | Date string dd/mm/yy | 00/00/00
-exclude | Wildcard filename(s) to exclude | Any string is accepted | An empty string is accepted
-indexoutdir | Index directory | Output directory | .

## Input file format

dbxflat reads any normal sequence USAs.

## Output file format

The indexing system has been designed to allow on-the-fly updating of indexes. This feature is, however, not implemented in the current version. It will be made available in future releases.

## References

None.

## Warnings

None.

## Diagnostic Error Messages

None.

## Exit status

It always exits with status 0.

## Known bugs

None.

## See also

Program name | Description
--- | ---
dbiblast | Index a BLAST database
dbifasta | Database indexing for fasta file databases
dbiflat | Index a flat file database
dbigcg | Index a GCG formatted database
dbxfasta | Database b+tree indexing for fasta file databases
dbxgcg | Database b+tree indexing for GCG formatted databases

## Author(s)

Alan Bleasby (ajb © ebi.ac.uk)
European Bioinformatics Institute, Wellcome Trust Genome Campus, Hinxton, Cambridge CB10 1SD, UK

## History

## Target users

This program is intended to be used by everyone and everything, from naive users to embedded scripts.

## Comments

None